import { Logger } from '../Helpers/';

export class CommandHelper {
  public Client: any;
  public Bot: any;
  public Message: any;
  public Channel: any;
  public Guild: any;
  public Stopwatch: any;
  public Author: any;
  public Log: Logger;

  constructor(client, msg) {
    this.Client = client;
    this.Bot = client;
    this.Message = msg;
    this.Channel = msg.channel;
    this.Guild = msg.channel.guild;
    this.Author = msg.author;
    this.Log = new Logger('Helper');
    this.Stopwatch = require('./../Util/Stopwatch');
  }

  public sendMessage(content) {
    try {
      return this.Channel.createMessage(content);
    } catch (err) {
      this.Log.warn(`sendMessage failed with ${err}`);
      return this.Channel.createMessage(`Something went wrong! ${err}`);
    }
  }

  public sendLocale(id) {
    try {
      return id;
    } catch (err) {
      this.Log.warn(`sendLocale failed with ${err}`);
      return;
    }
  }
}
