import { AliasModule } from '../Modules';
import { CommandHelper } from '../Classes/CommandHelper';

export class BaseCommand extends AliasModule {
  public aliases: any;
  public permission: string;
  public help: string;
  constructor(client, handler, file, dir, options) {
    super(client, handler, file, dir, options);

    this.name = this.name.toLowerCase();

    this.disabled = options.disabled;

    this.permission = options.Permission || 'everyone';

    this.help = options.help || 'No help specified';
  }

  public static async run(Helper: CommandHelper, params): Promise<void> {
    throw Error('Command does not override run function');
  }
}
