import * as Bunyan from 'bunyan';
import * as Path from 'path';

export class Logger{
  public client: any;
  public info: Function;
  public debug: Function;
  public warn: Function;
  public error: Function;

  constructor(app) {
    return Bunyan.createLogger({
      name: app,
      src: false,
      serializers: Bunyan.stdSerializers,
      streams: [
        {
          level: 'debug',
          stream: process.stdout,
        },
        {
          path: Path.join('logs/', 'zenith.log'),
          type: 'rotating-file',
          level: 'debug',
          period: '1d',
        },
      ],
    });
  }

}
