const Messages = {
  // Modules
  FILE_NOT_FOUND: filename => `File ${filename} not found.`,
  COMMAND_EXISTS: filename => `Command ${filename} already exists.`,
  EVENT_EXISTS: filename => `Event ${filename} already exists.`,
  PERMISSION_EXISTS: filename => `Permission ${filename} already exists.`,

  // Commands
  PREFIX_TOO_LONG: 'Prefix exceeds 6 character limit!',
};

export class ZenithError extends Error{
  private readonly code:string;
  constructor(key, ...args) {
    if (Messages[key] === null) throw new TypeError(`Error key '${key}' doesn't exist.`);
    const message = typeof Messages[key] === 'function'  ? Messages[key](...args)  : Messages[key];
    super(message);
    this.code = key;
  }

  get name() {
    return `ZenithError [${this.code}]`;
  }
}
