import { ZenithClient, Config } from '../src';
import * as _ from 'lodash';
import * as Cache from 'memory-cache';

if (_.isNull(Cache.get('configfile'))) {
  Cache.put('configfile', `${__dirname}\\config.json`);
}
const config: Config = new Config();

const token = config.get('token', '');

const clientOptions = {
  dir: __dirname,
  firstShardID: 0,
  lastShardID: 0,
  maxShards: 1,
};

class Zenith extends ZenithClient {
  constructor() {
    super({
      token,
      clientOptions,
    });
  }
}

new Zenith().start();
